#include "pitches.h" // Include library to make sounds with the buzzer
const int candle = 11; // LED pin number
const int candle1 = 5; // LED pin number
const int candle2 = 9; // LED pin number
const int candle3 = 3; // LED pin number
const int musiPin = 10; // Passive buzzer pin number
int melody[] = {NOTE_CS6, NOTE_FS5, NOTE_FS5, NOTE_CS6, NOTE_FS5, NOTE_FS5, NOTE_CS6, NOTE_D5, NOTE_FS5,
                NOTE_CS6, NOTE_FS5, NOTE_FS5, NOTE_CS6, NOTE_FS5, NOTE_FS5, NOTE_CS6, NOTE_D5, NOTE_FS5,
                NOTE_C6, NOTE_F5, NOTE_F5, NOTE_C6, NOTE_F5, NOTE_F5, NOTE_C6, NOTE_F5, NOTE_CS5, NOTE_F5,
                NOTE_C6, NOTE_F5, NOTE_F5, NOTE_C6, NOTE_F5, NOTE_F5, NOTE_C6, NOTE_F5, NOTE_CS5, NOTE_F5,
                NOTE_B5, NOTE_E5, NOTE_E5, NOTE_B5, NOTE_E5, NOTE_E5, NOTE_B5, NOTE_E5, NOTE_C6, NOTE_E5,
                NOTE_B5, NOTE_E5, NOTE_E5, NOTE_B5, NOTE_E5, NOTE_E5, NOTE_B5, NOTE_E5, NOTE_C6, NOTE_E5
               }; // Array with all the melody's notes
int noteDurations[] = {4, 4, 4, 4, 4, 4, 4, 4, 4,
                       4, 4, 4, 4, 4, 4, 4, 4, 4,
                       4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
                       4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
                       4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
                       4, 4, 4, 4, 4, 4, 4, 4, 4, 4
                      }; // Array with the intervals between each notes of the array from above int melody[]
void setup() { //Inicialize and ser initial values
  Serial.begin(9600); // opens serial port, sets data rate to 9600 bps. It's used for reading the photoresistor
}

void loop() { // Conecutively repeat this thread of code
  int sensorvalue = analogRead (A0); // We recieve the data from the photoresistor and convert it into an integer
  Serial.println(sensorvalue); // This is just to make sure that de photoresistor works
  if (sensorvalue > 200) { // Condition set when there is light
    analogWrite(candle, 255); // Sets the LED 1 to full brightness
    analogWrite(candle1, 255); // Sets the LED 2 to full brightness
    analogWrite(candle2, 255); // Sets the LED 3 to full brightness
    analogWrite(candle3, 255); // Sets the LED 4 to full brightness

    int musicPin = 10; // Declare the passive buzzer pin number

    for (int thisNote = 0; thisNote < 58; thisNote++) { // Create a loop
      // to calculate the note duration, take one second
      // divided by the note type.
      //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
      int noteDuration = 1000 / noteDurations[thisNote];
      tone(musicPin, melody[thisNote], noteDuration); //Delivers sound to the music pin with the specified note duration and note sound.
      // to distinguish the notes, set a minimum time between them.
      // the note's duration + 30% seems to work well:
      int pauseBetweenNotes = noteDuration * 1.30;
      delay(pauseBetweenNotes);

     sensorvalue = analogRead (A0); // We recieve the data from the photoresistor and convert it into an integer
      if (sensorvalue < 150) // If the photoresistor is no longer exposed to light...
      {
        break; // Stop all the reading of the array so the music stops immediately.
      }
    }

  }
  else // Otherwise...
  {
    analogWrite(candle, random(0, 256)); //Set LED 1 to make random flicks of light so that it immitates a candle
    delay(25); // A delay of 25ms seems to make it look more like a real candle
    analogWrite(candle1, random(0, 256)); //Set LED 2 to make random flicks of light so that it immitates a candle
    delay(25); // A delay of 25ms seems to make it look more like a real candle
    analogWrite(candle2, random(0, 256)); //Set LED 3 to make random flicks of light so that it immitates a candle
    delay(25); // A delay of 25ms seems to make it look more like a real candle
    analogWrite(candle3, random(0, 256)); //Set LED 4 to make random flicks of light so that it immitates a candle
    delay(25); // A delay of 25ms seems to make it look more like a real candle
  }


}
